package be.jeffcheasey88.peeratcode.parser.java;

import java.lang.reflect.Modifier;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import be.jeffcheasey88.peeratcode.parser.java.CleanerPool.Cleaner;

public class Variable {
	
	private static Pattern PATTERN = Pattern.compile("^(\\s*)(.*)$");
	
	private int modifier;
	private String name;
	private String type;
	private Variable value;
	
	public Variable(){}
	
	public Variable(int modifier, String type){
		this.modifier = modifier;
		this.type = type;
	}
	
	public int parse(String content, CleanerPool cleaner) throws Exception{
		System.out.println("parse "+content);
		CleanerPool generic = new CleanerPool(new Cleaner("GENERIC_TYPE_",'<','>'));
		content = generic.clean(content);
		System.out.println("clean "+content);
		
		Matcher matcher = PATTERN.matcher(content);
		matcher.matches();
		
		int offset = matcher.group(1).length();

		String body = matcher.group(2);
		int equals = indexOf(body, "=");
		int quote = indexOf(body,",");
		int quotes = indexOf(body, ";");
		int min = Math.min(quote, quotes);
		body = body.substring(0, min);
		
		if(equals < quote && equals < quotes){
			assigment(body, generic);
		}else{
			onlyDefine(body, generic);
		}
		
		return offset+min;
	}
	
	private void assigment(String content, CleanerPool cleaner){
	}
	
	private void onlyDefine(String content, CleanerPool cleaner){
		System.out.println("onlyDefine "+content);
		content = generiqueTypes(content, cleaner);
		System.out.println(content);
		String[] values = content.split("\\s+");
		for(String value : values){
			int modifier = JavaParser.getModifier(value);
			if(modifier > 0){
				this.modifier+=modifier;
				continue;
			}
			if(this.type == null){
				this.type = value;
				continue;
			}
			this.name = value;
		}
	}
	
	private String generiqueTypes(String content, CleanerPool cleaner){
		return cleaner.unzip(content, (s) -> s.replaceAll("\\s+", "")).replaceAll(">(?<varname>[^>\\d,;])", "> ${varname}");
	}
	
	private int indexOf(String value, String target){
		return value.split(target)[0].length();
	}
	
	public int getModifier(){
		return this.modifier;
	}
	
	public String getName(){
		return this.name;
	}
	
	public String getType(){
		return this.type;
	}
	
	public Variable getValue(){
		return this.value;
	}
	
	public void show(int tab){
		String start = "";
		for(int i = 0; i < tab; i++) start+="\t";
		System.out.println(start+Modifier.toString(modifier)+" "+type+" "+name+(value == null ? ";":"="+value+";"));
	}
	
	public static class Value extends Variable{
		
		private String value;
		
		public Value(String value){
			this.value = value;
		}
		
		public String value(){
			return this.value;
		}
		
		@Override
		public String toString(){
			return this.value;
		}
	}
}
